package dev.shadowsoffire.apotheosis.spawn.spawner;

import java.util.function.Supplier;
import net.minecraft.world.flag.FeatureFlagSet;
import net.minecraft.world.phys.Vec3;
import net.minecraft.world.level.LightLayer;
import net.minecraft.world.level.border.WorldBorder;
import net.minecraft.world.level.material.FluidState;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.lighting.LevelLightEngine;
import net.minecraft.core.Direction;
import net.minecraft.world.level.dimension.DimensionType;
import net.minecraft.world.level.biome.Biome;
import net.minecraft.core.Holder;
import net.minecraft.world.level.biome.BiomeManager;
import net.minecraft.world.level.levelgen.Heightmap;
import net.minecraft.world.level.chunk.ChunkAccess;
import net.minecraft.world.level.chunk.ChunkStatus;
import net.minecraft.world.level.entity.EntityTypeTest;
import java.util.List;
import java.util.function.Predicate;
import net.minecraft.world.phys.AABB;
import net.minecraft.core.RegistryAccess;
import net.minecraft.world.level.gameevent.GameEvent;
import net.minecraft.world.entity.Entity;
import net.minecraft.core.particles.ParticleOptions;
import net.minecraft.sounds.SoundSource;
import net.minecraft.sounds.SoundEvent;
import net.minecraft.world.entity.player.Player;
import net.minecraft.util.RandomSource;
import net.minecraft.world.level.chunk.ChunkSource;
import net.minecraft.server.MinecraftServer;
import net.minecraft.world.DifficultyInstance;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.storage.LevelData;
import net.minecraft.world.level.material.Fluid;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.ticks.LevelTickAccess;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.world.level.WorldGenLevel;

public class LyingLevel implements WorldGenLevel
{
    protected final ServerLevel wrapped;
    protected int fakeLightLevel;
    
    public LyingLevel(final ServerLevel wrapped) {
        this.wrapped = wrapped;
    }
    
    public void setFakeLightLevel(final int light) {
        this.fakeLightLevel = light;
    }
    
    public long m_183596_() {
        return this.wrapped.m_183596_();
    }
    
    public LevelTickAccess<Block> m_183326_() {
        return (LevelTickAccess<Block>)this.wrapped.m_183326_();
    }
    
    public LevelTickAccess<Fluid> m_183324_() {
        return (LevelTickAccess<Fluid>)this.wrapped.m_183324_();
    }
    
    public LevelData m_6106_() {
        return this.wrapped.m_6106_();
    }
    
    public DifficultyInstance m_6436_(final BlockPos pPos) {
        return this.wrapped.m_6436_(pPos);
    }
    
    public MinecraftServer m_7654_() {
        return this.wrapped.m_7654_();
    }
    
    public ChunkSource m_7726_() {
        return (ChunkSource)this.wrapped.m_7726_();
    }
    
    public RandomSource m_213780_() {
        return this.wrapped.m_213780_();
    }
    
    public void m_5594_(final Player pPlayer, final BlockPos pPos, final SoundEvent pSound, final SoundSource pCategory, final float pVolume, final float pPitch) {
        this.wrapped.m_5594_(pPlayer, pPos, pSound, pCategory, pVolume, pPitch);
    }
    
    public void m_7106_(final ParticleOptions pParticleData, final double pX, final double pY, final double pZ, final double pXSpeed, final double pYSpeed, final double pZSpeed) {
        this.wrapped.m_7106_(pParticleData, pX, pY, pZ, pXSpeed, pYSpeed, pZSpeed);
    }
    
    public void m_5898_(final Player pPlayer, final int pType, final BlockPos pPos, final int pData) {
        this.wrapped.m_5898_(pPlayer, pType, pPos, pData);
    }
    
    public void m_142346_(final Entity pEntity, final GameEvent pEvent, final BlockPos pPos) {
        this.wrapped.m_142346_(pEntity, pEvent, pPos);
    }
    
    public RegistryAccess m_9598_() {
        return this.wrapped.m_9598_();
    }
    
    public List<Entity> m_6249_(final Entity pEntity, final AABB pArea, final Predicate<? super Entity> pPredicate) {
        return this.wrapped.m_6249_(pEntity, pArea, (Predicate)pPredicate);
    }
    
    public <T extends Entity> List<T> m_142425_(final EntityTypeTest<Entity, T> pEntityTypeTest, final AABB pArea, final Predicate<? super T> pPredicate) {
        return this.wrapped.m_142425_((EntityTypeTest)pEntityTypeTest, pArea, (Predicate)pPredicate);
    }
    
    public List<? extends Player> m_6907_() {
        return this.wrapped.m_6907_();
    }
    
    public ChunkAccess m_6522_(final int pX, final int pZ, final ChunkStatus pRequiredStatus, final boolean pNonnull) {
        return this.wrapped.m_6522_(pX, pZ, pRequiredStatus, pNonnull);
    }
    
    public int m_6924_(final Heightmap.Types pHeightmapType, final int pX, final int pZ) {
        return this.wrapped.m_6924_(pHeightmapType, pX, pZ);
    }
    
    public int m_7445_() {
        return this.wrapped.m_7445_();
    }
    
    public BiomeManager m_7062_() {
        return this.wrapped.m_7062_();
    }
    
    public Holder<Biome> m_203675_(final int pX, final int pY, final int pZ) {
        return (Holder<Biome>)this.wrapped.m_203675_(pX, pY, pZ);
    }
    
    public boolean m_5776_() {
        return this.wrapped.m_5776_();
    }
    
    public int m_5736_() {
        return this.wrapped.m_5736_();
    }
    
    public DimensionType m_6042_() {
        return this.wrapped.m_6042_();
    }
    
    public float m_7717_(final Direction pDirection, final boolean pShade) {
        return this.wrapped.m_7717_(pDirection, pShade);
    }
    
    public LevelLightEngine m_5518_() {
        return this.wrapped.m_5518_();
    }
    
    public BlockEntity m_7702_(final BlockPos pPos) {
        return this.wrapped.m_7702_(pPos);
    }
    
    public BlockState m_8055_(final BlockPos p_45571_) {
        return this.wrapped.m_8055_(p_45571_);
    }
    
    public FluidState m_6425_(final BlockPos pPos) {
        return this.wrapped.m_6425_(pPos);
    }
    
    public WorldBorder m_6857_() {
        return this.wrapped.m_6857_();
    }
    
    public boolean m_7433_(final BlockPos pPos, final Predicate<BlockState> pState) {
        return this.wrapped.m_7433_(pPos, (Predicate)pState);
    }
    
    public boolean m_142433_(final BlockPos pPos, final Predicate<FluidState> pPredicate) {
        return this.wrapped.m_142433_(pPos, (Predicate)pPredicate);
    }
    
    public boolean m_6933_(final BlockPos pPos, final BlockState pState, final int pFlags, final int pRecursionLeft) {
        return this.wrapped.m_6933_(pPos, pState, pFlags, pRecursionLeft);
    }
    
    public boolean m_7471_(final BlockPos pPos, final boolean pIsMoving) {
        return this.wrapped.m_7471_(pPos, pIsMoving);
    }
    
    public boolean m_7740_(final BlockPos pPos, final boolean pDropBlock, final Entity pEntity, final int pRecursionLeft) {
        return this.wrapped.m_7740_(pPos, pDropBlock, pEntity, pRecursionLeft);
    }
    
    public ServerLevel m_6018_() {
        return this.wrapped;
    }
    
    public int m_45517_(final LightLayer pLightType, final BlockPos pBlockPos) {
        return this.fakeLightLevel;
    }
    
    public int m_45524_(final BlockPos pBlockPos, final int pAmount) {
        return this.fakeLightLevel;
    }
    
    public long m_7328_() {
        return this.wrapped.m_7328_();
    }
    
    public void m_214171_(final GameEvent pEvent, final Vec3 pPosition, final GameEvent.Context pContext) {
        this.wrapped.m_214171_(pEvent, pPosition, pContext);
    }
    
    public FeatureFlagSet m_246046_() {
        return this.wrapped.m_246046_();
    }
    
    public boolean m_180807_(final BlockPos pPos) {
        return this.wrapped.m_180807_(pPos);
    }
    
    public void m_143497_(final Supplier<String> pCurrentlyGenerating) {
        this.wrapped.m_143497_((Supplier)pCurrentlyGenerating);
    }
    
    public void m_47205_(final Entity pEntity) {
        this.wrapped.m_47205_(pEntity);
    }
    
    public void m_6289_(final BlockPos pPos, final Block pBlock) {
        this.wrapped.m_6289_(pPos, pBlock);
    }
    
    public boolean m_7967_(final Entity pEntity) {
        return this.wrapped.m_7967_(pEntity);
    }
}
